; sound

!ifdef INCLUDE_SOUND !eof
!if INCLUDE_GUARD > 0 {
INCLUDE_SOUND = 1
}

!zn Sound {

SND_ATTACK = 0
SND_BEAM = 1
SND_CHOSEN = 2
SND_CPUSTART = 3
SND_ELECTRO = 4
SND_FIRE = 5
SND_GOOEY = 6
SND_JUSTICE = 7
SND_MENU = 8
SND_RANGE = 9
SND_SCREAM = $a
SND_SPELLSTEP = $b
SND_SPELLSUCCESS = $c
SND_URGH = $d
SND_WALK = $e
SND_OFF = $f

!src "sfxdata.asm"

sfx_enabled = Sfx_zp_base + 0
sfx_ptr = Sfx_zp_base + 1
sfx_ptrh = Sfx_zp_base + 2
sfx_pos = Sfx_zp_base + 3
sfx_delay = Sfx_zp_base + 4
sfx_tmp = Sfx_zp_base + 5

sfx_tick:
    lda sfx_enabled
    bne +
    rts
+
sfx_play_smc_ch_base = * + 1
!if SFX_NEED_CHA > 0 {
sfx_play_smc_cha = * + 1
    lda #$00
    sta $900a
}
!if SFX_NEED_CHB > 0 {
sfx_play_smc_chb = * + 1
    lda #$00
    sta $900b
}
!if SFX_NEED_CHC > 0 {
sfx_play_smc_chc = * + 1
    lda #$00
    sta $900c
}
!if SFX_NEED_CHD > 0 {
sfx_play_smc_chd = * + 1
    lda #$00
    sta $900d
}
!if SFX_NEED_CHE > 0 {
sfx_play_smc_che = * + 1
    lda #SOUND_VOLUME
    sta $900e
}

    ; TODO mod

    dec sfx_delay
    beq +
    rts
+
    ; first byte is %abcdezzz where abcde are "channel N data follows" bits and zzz is delay
    ldy sfx_pos
    lda (sfx_ptr),y
    bne +
    ; special value 0: stop
    jmp sfx_stop
+   sta sfx_tmp
    and #SFX_MASK_DELAY
    sta sfx_delay
    iny
    ; channel data bytes follow
    ldx #0  ; channel counter
--  rol sfx_tmp
    bcc +
    ; bit 7-x was set, channel x has data
    stx sfx_tick_smc_x
    lda tbl_sfx_offs_chval,x
    tax
    lda (sfx_ptr),y
    ; TODO implement channel commands
    sta sfx_play_smc_ch_base,x
    iny
    beq sfx_stop    ; full $100 byte long sfx reached end
sfx_tick_smc_x = * + 1
    ldx #0
+   inx
    cpx #SFX_NUM_CHBITS
    bne --
    sty sfx_pos
    rts


sfx_stop:
    lda #0
    sta sfx_enabled
    sta $900a
    sta $900b
    sta $900c
    sta $900d
    sta sfx_pos
    sta sfx_delay
!if SFX_NEED_CHA > 0 {
    sta sfx_play_smc_cha
}
!if SFX_NEED_CHB > 0 {
    sta sfx_play_smc_chb
}
!if SFX_NEED_CHC > 0 {
    sta sfx_play_smc_chc
}
!if SFX_NEED_CHD > 0 {
    sta sfx_play_smc_chd
}
    lda #SOUND_VOLUME
    sta $900e
!if SFX_NEED_CHE > 0 {
    sta sfx_play_smc_che
}
    rts

; in:
; a = sound id
sound_play:
    stx sfx_play_smc_x
    tax
    jsr sfx_stop
    cpx #SFX_NUM
    bcs +
    lda tbl_sfx_addr_l,x
    sta sfx_ptr
    lda tbl_sfx_addr_h,x
    sta sfx_ptrh
    inc sfx_delay
    inc sfx_enabled
+
sfx_play_smc_x = * + 1
    ldx #0
    rts

} ; !zn Sound
