; spell/creature data and helper functions

!ifdef INCLUDE_SPELLS !eof
!if INCLUDE_GUARD > 0 {
INCLUDE_SPELLS = 1
}

!zn Spells {

SPELL_NONE = 0
SPELL_DISBELIEVE = 1
SPELL_KING_COBRA = 2
SPELL_DIRE_WOLF = 3
SPELL_GOBLIN = 4
SPELL_CROCODILE = 5
SPELL_TROLL = 6
SPELL_FAUN = 7
SPELL_LION = 8
SPELL_ELF = 9
SPELL_ORC = 10
SPELL_BEAR = 11
SPELL_GORILLA = 12
SPELL_OGRE = 13
SPELL_HYDRA = 14
SPELL_GIANT_RAT = 15
SPELL_GIANT = 16
SPELL_HORSE = 17
SPELL_UNICORN = 18
SPELL_CENTAUR = 19
SPELL_PEGASUS = 20
SPELL_GRYPHON = 21
SPELL_MANTICORE = 22
SPELL_BAT = 23
SPELL_DRAGON_GREEN = 24
SPELL_DRAGON_RED = 25
SPELL_DRAGON_GOLDEN = 26
SPELL_HARPY = 27
SPELL_EAGLE = 28
SPELL_VAMPIRE = 29
SPELL_GHOST = 30
SPELL_SPECTRE = 31
SPELL_WRAITH = 32
SPELL_SKELETON = 33
SPELL_ZOMBIE = 34
SPELL_GOOEY_BLOB = 35
SPELL_MAGIC_FIRE = 36
SPELL_MAGIC_WOOD = 37
SPELL_SHADOW_WOOD = 38
SPELL_MAGIC_CASTLE = 39
SPELL_DARK_CITADEL = 40
SPELL_WALL = 41
SPELL_MAGIC_BOLT = 42
SPELL_LIGHTNING = 43
SPELL_VENGEANCE = 44
SPELL_DECREE = 45
SPELL_DARK_POWER = 46
SPELL_JUSTICE = 47
SPELL_MAGIC_SHIELD = 48
SPELL_MAGIC_ARMOUR = 49
SPELL_MAGIC_SWORD = 50
SPELL_MAGIC_KNIFE = 51
SPELL_MAGIC_BOW = 52
SPELL_MAGIC_WINGS = 53
SPELL_LAW_1 = 54
SPELL_LAW_2 = 55
SPELL_CHAOS_1 = 56
SPELL_CHAOS_2 = 57
SPELL_SHADOW_FORM = 58
SPELL_SUBVERSION = 59
SPELL_RAISE_DEAD = 60
SPELL_TURMOIL = 61


.spellcollmask:
.SPCOLL_NONE = (* - .spellcollmask) / 8
!by 0, 0, 0, 0, 0, 0, 0, 0
.SPCOLL_FULL = (* - .spellcollmask) / 8
!by $ff, $ff, $ff, $ff, $ff, $ff, $ff, $ff
.SPCOLL_TINYLOW = (* - .spellcollmask) / 8
!by %........
!by %........
!by %........
!by %........
!by %........
!by %...#....
!by %..###...
!by %........
.SPCOLL_LOWWIDE = (* - .spellcollmask) / 8
!by %........
!by %........
!by %........
!by %........
!by %.##..#..
!by %.######.
!by %.######.
!by %........
.SPCOLL_THIN = (* - .spellcollmask) / 8
!by %........
!by %........
!by %...##...
!by %...##...
!by %...##...
!by %...##...
!by %...##...
!by %........
.SPCOLL_MEDIUM = (* - .spellcollmask) / 8
!by %........
!by %...##...
!by %..####..
!by %..####..
!by %..####..
!by %..####..
!by %...##...
!by %........
.SPCOLL_LARGE = (* - .spellcollmask) / 8
!by %........
!by %.######.
!by %.######.
!by %.######.
!by %.######.
!by %.######.
!by %.######.
!by %........

!macro creaturedatad .combat, .rangedc, .rangedr, .defence, .movement, .manvr, .magicres, .coll {
!by (.combat << 4) | (.defence)
!by (.rangedc << 4) | (.rangedr)
!by (.movement << 4) | (.manvr)
!by (.coll << 4) | (.magicres)
}

creaturedata_packed = * - (2 * 4)   ; make table zero based
; 2 - King Cobra
+creaturedatad 4, 0, 0, 1, 1, 6, 1, .SPCOLL_TINYLOW
; 3 - Dire Wolf
+creaturedatad 3, 0, 0, 2, 3, 7, 2, .SPCOLL_LOWWIDE
; 4 - Goblin
+creaturedatad 2, 0, 0, 4, 1, 4, 4, .SPCOLL_THIN
; 5 - Crocodile
+creaturedatad 5, 0, 0, 6, 1, 2, 2, .SPCOLL_LOWWIDE
; 6 - Troll
+creaturedatad 4, 0, 0, 8, 1, 1, 4, .SPCOLL_LARGE
; 7 - Faun
+creaturedatad 3, 0, 0, 2, 1, 7, 8, .SPCOLL_THIN
; 8 - Lion
+creaturedatad 6, 0, 0, 4, 4, 8, 3, .SPCOLL_LOWWIDE
; 9 - Elf
+creaturedatad 1, 2, 6, 2, 1, 5, 7, .SPCOLL_MEDIUM
; 10 - Orc
+creaturedatad 2, 0, 0, 1, 1, 4, 4, .SPCOLL_MEDIUM
; 11 - Bear
+creaturedatad 6, 0, 0, 7, 2, 6, 2, .SPCOLL_MEDIUM
; 12 - Gorilla
+creaturedatad 6, 0, 0, 5, 1, 4, 2, .SPCOLL_MEDIUM
; 13 - Ogre
+creaturedatad 4, 0, 0, 7, 1, 3, 6, .SPCOLL_LARGE
; 14 - Hydra
+creaturedatad 7, 0, 0, 8, 1, 4, 6, .SPCOLL_LARGE
; 15 - Giant Rat
+creaturedatad 1, 0, 0, 1, 3, 8, 2, .SPCOLL_LOWWIDE
; 16 - Giant
+creaturedatad 9, 0, 0, 7, 2, 6, 5, .SPCOLL_LARGE
; 17 - Horse
+creaturedatad 1, 0, 0, 3, 4, 8, 1, .SPCOLL_LOWWIDE
; 18 - Unicorn
+creaturedatad 5, 0, 0, 4, 4, 9, 7, .SPCOLL_LOWWIDE
; 19 - Centaur
+creaturedatad 1, 2, 4, 3, 4, 5, 5, .SPCOLL_LOWWIDE
; 20 - Pegasus
+creaturedatad 2, 0, 0, 4, 5, 6, 7, .SPCOLL_LOWWIDE
; 21 - Gryphon
+creaturedatad 3, 0, 0, 5, 5, 5, 6, .SPCOLL_LOWWIDE
; 22 - Manticore
+creaturedatad 3, 1, 3, 6, 5, 6, 8, .SPCOLL_LOWWIDE
; 23 - Bat
+creaturedatad 1, 0, 0, 1, 5, 9, 4, .SPCOLL_TINYLOW
; 24 - Green Dragon
+creaturedatad 5, 4, 6, 8, 3, 4, 4, .SPCOLL_LARGE
; 25 - Red Dragon
+creaturedatad 7, 3, 5, 9, 3, 4, 5, .SPCOLL_LARGE
; 26 - Golden Dragon
+creaturedatad 9, 5, 4, 9, 3, 5, 5, .SPCOLL_LARGE
; 27 - Harpy
+creaturedatad 4, 0, 0, 2, 5, 8, 5, .SPCOLL_MEDIUM
; 28 - Eagle
+creaturedatad 3, 0, 0, 3, 6, 8, 2, .SPCOLL_MEDIUM
; 29 - Vampire
+creaturedatad 6, 0, 0, 8, 4, 6, 5, .SPCOLL_MEDIUM
; 30 - Ghost
+creaturedatad 1, 0, 0, 3, 2, 9, 6, .SPCOLL_NONE
; 31 - Spectre
+creaturedatad 4, 0, 0, 2, 1, 6, 4, .SPCOLL_THIN
; 32 - Wraith
+creaturedatad 5, 0, 0, 5, 2, 4, 5, .SPCOLL_NONE
; 33 - Skeleton
+creaturedatad 3, 0, 0, 2, 1, 3, 4, .SPCOLL_THIN
; 34 - Zombie
+creaturedatad 1, 0, 0, 1, 1, 2, 3, .SPCOLL_THIN
; for the collision
; 35 - Gooey Blob
+creaturedatad 0, 0, 0, 0, 0, 0, 0, .SPCOLL_MEDIUM
; 36 - Magic Fire
+creaturedatad 0, 0, 0, 0, 0, 0, 0, .SPCOLL_NONE
; 37 - Magic Wood
+creaturedatad 0, 0, 0, 0, 0, 0, 0, .SPCOLL_MEDIUM
; 38 - Shadow Wood
+creaturedatad 0, 0, 0, 0, 0, 0, 0, .SPCOLL_MEDIUM
; 39 - Magic Castle
+creaturedatad 0, 0, 0, 0, 0, 0, 0, .SPCOLL_LARGE
; 40 - Dark Citadel
+creaturedatad 0, 0, 0, 0, 0, 0, 0, .SPCOLL_LARGE
; 41 - Wall
+creaturedatad 0, 0, 0, 0, 0, 0, 0, .SPCOLL_FULL


; in:
; a = creature
; out:
; mptr:h -> creature collision mask
creature_get_collision:
    pha
    lda #>.spellcollmask
    sta mptrh
    lda #<.spellcollmask
    sta mptr
    pla
    cmp #0
    bne +
    rts
+
    cmp #WIZARD_INDEX
    bcc ++
    lda #.SPCOLL_MEDIUM * 8
    bcs +++ ; bra
++
    sty .creature_get_collision_y
    asl
    asl
    tay
    lda creaturedata_packed + 3,y
.creature_get_collision_y = * + 1
    ldy #0
    lsr
    and #%01111000
+++
    clc
    adc mptr
    sta mptr
    bcc +
    inc mptrh
+   rts


; in:
; a = creature
; out:
; a = defence
creature_get_def:
    cmp #WIZARD_INDEX
    bcc .creature_get_def_creature
    ; wizard
    ; sec
    sbc #WIZARD_INDEX
    tay
    ldx wizard_offs,y
    lda player_data + PDATA_OFFS_COMBAT_DEF,x
    and #$f
    tay
    lda player_data + PDATA_OFFS_FLAGS1,x
    bmi +   ; magic armor, +4 def
    and #PDATA_MASK_FLAGS1_SHIELD
    bne ++  ; magic shield, +2 def
    beq +++
+   iny
    iny
++  iny
    iny
+++ tya
    rts
.creature_get_def_creature:
    ; creature
    asl
    asl
    tay
    lda creaturedata_packed,y
    and #$f
    rts


; in:
; a = creature
; out:
; a = magic resistance
creature_get_magic_res:
    cmp #WIZARD_INDEX
    bcc .creature_get_magic_res_creature
    ; wizard
    ; sec
    sbc #WIZARD_INDEX
    tay
    ldx wizard_offs,y
    lda player_data + PDATA_OFFS_MRES,x
    and #$f
    rts
.creature_get_magic_res_creature:
    ; creature
    asl
    asl
    tay
    lda creaturedata_packed + 3,y
    and #$f
    rts


!macro spelldatad .chaos, .castch, .castr, .aiprio {
!by (.chaos << 4) | (.aiprio)
!by (.castr << 4) | (.castch)
}

.SP_CHAOS_M4 = 0
.SP_CHAOS_M2 = 1
.SP_CHAOS_M1 = 2
.SP_CHAOS_0 = 3
.SP_CHAOS_P1 = 4
.SP_CHAOS_P2 = 5
.SP_CHAOS_P4 = 6

tbl_spelldata_chaos:
!by -4, -2, -1, 0, 1, 2, 4

.SP_CASTR_0 = 0
.SP_CASTR_3 = 1
.SP_CASTR_9 = 2
.SP_CASTR_13 = 3
.SP_CASTR_15 = 4
.SP_CASTR_17 = 5
.SP_CASTR_41 = 6

tbl_spelldata_castrange:
!by 0, 3, 9, 13, 15, 17, 41

.SP_AIPRIO_0 = 0
.SP_AIPRIO_5 = 1
.SP_AIPRIO_6 = 2
.SP_AIPRIO_11 = 3
.SP_AIPRIO_12 = 4
.SP_AIPRIO_14 = 5
.SP_AIPRIO_16 = 6
.SP_AIPRIO_17 = 7
.SP_AIPRIO_18 = 8
.SP_AIPRIO_23 = 9

tbl_spelldata_aiprio:
!by 0, 5, 6, 11, 12, 14, 16, 17, 18, 23

spelldata_packed = * - (1 * 2)  ; make table zero based
; 1 - Disbelieve
+spelldatad .SP_CHAOS_0,  10, .SP_CASTR_41, .SP_AIPRIO_0
; 2 - King Cobra
+spelldatad .SP_CHAOS_P1, 10, .SP_CASTR_3,  .SP_AIPRIO_18
; 3 - Dire Wolf
+spelldatad .SP_CHAOS_M1, 9,  .SP_CASTR_3,  .SP_AIPRIO_18
; 4 - Goblin
+spelldatad .SP_CHAOS_M1, 9,  .SP_CASTR_3,  .SP_AIPRIO_18
; 5 - Crocodile
+spelldatad .SP_CHAOS_0,  8,  .SP_CASTR_3,  .SP_AIPRIO_18
; 6 - Troll
+spelldatad .SP_CHAOS_M1, 6,  .SP_CASTR_3,  .SP_AIPRIO_18
; 7 - Faun
+spelldatad .SP_CHAOS_M1, 8,  .SP_CASTR_3,  .SP_AIPRIO_18
; 8 - Lion
+spelldatad .SP_CHAOS_P1, 6,  .SP_CASTR_3,  .SP_AIPRIO_18
; 9 - Elf
+spelldatad .SP_CHAOS_P2, 7,  .SP_CASTR_3,  .SP_AIPRIO_18
; 10 - Orc
+spelldatad .SP_CHAOS_M1, 10, .SP_CASTR_3,  .SP_AIPRIO_18
; 11 - Bear
+spelldatad .SP_CHAOS_P1, 6,  .SP_CASTR_3,  .SP_AIPRIO_18
; 12 - Gorilla
+spelldatad .SP_CHAOS_0,  7,  .SP_CASTR_3,  .SP_AIPRIO_18
; 13 - Ogre
+spelldatad .SP_CHAOS_M1, 7,  .SP_CASTR_3,  .SP_AIPRIO_18
; 14 - Hydra
+spelldatad .SP_CHAOS_M1, 5,  .SP_CASTR_3,  .SP_AIPRIO_18
; 15 - Giant Rat
+spelldatad .SP_CHAOS_0,  10, .SP_CASTR_3,  .SP_AIPRIO_18
; 16 - Giant
+spelldatad .SP_CHAOS_P1, 4,  .SP_CASTR_3,  .SP_AIPRIO_18
; 17 - Horse
+spelldatad .SP_CHAOS_P1, 9,  .SP_CASTR_3,  .SP_AIPRIO_18
; 18 - Unicorn
+spelldatad .SP_CHAOS_P2, 6,  .SP_CASTR_3,  .SP_AIPRIO_18
; 19 - Centaur
+spelldatad .SP_CHAOS_P1, 7,  .SP_CASTR_3,  .SP_AIPRIO_18
; 20 - Pegasus
+spelldatad .SP_CHAOS_P2, 7,  .SP_CASTR_3,  .SP_AIPRIO_18
; 21 - Gryphon
+spelldatad .SP_CHAOS_P1, 6,  .SP_CASTR_3,  .SP_AIPRIO_18
; 22 - Manticore
+spelldatad .SP_CHAOS_M1, 4,  .SP_CASTR_3,  .SP_AIPRIO_18
; 23 - Bat
+spelldatad .SP_CHAOS_M1, 8,  .SP_CASTR_3,  .SP_AIPRIO_18
; 24 - Green Dragon
+spelldatad .SP_CHAOS_M1, 2,  .SP_CASTR_3,  .SP_AIPRIO_18
; 25 - Red Dragon
+spelldatad .SP_CHAOS_M2, 1,  .SP_CASTR_3,  .SP_AIPRIO_18
; 26 - Golden Dragon
+spelldatad .SP_CHAOS_P2, 2,  .SP_CASTR_3,  .SP_AIPRIO_18
; 27 - Harpy
+spelldatad .SP_CHAOS_M1, 7,  .SP_CASTR_3,  .SP_AIPRIO_18
; 28 - Eagle
+spelldatad .SP_CHAOS_P1, 7,  .SP_CASTR_3,  .SP_AIPRIO_18
; 29 - Vampire
+spelldatad .SP_CHAOS_M2, 2,  .SP_CASTR_3,  .SP_AIPRIO_18
; 30 - Ghost
+spelldatad .SP_CHAOS_M1, 5,  .SP_CASTR_3,  .SP_AIPRIO_18
; 31 - Spectre
+spelldatad .SP_CHAOS_M1, 6,  .SP_CASTR_3,  .SP_AIPRIO_18
; 32 - Wraith
+spelldatad .SP_CHAOS_M1, 6,  .SP_CASTR_3,  .SP_AIPRIO_18
; 33 - Skeleton
+spelldatad .SP_CHAOS_M1, 7,  .SP_CASTR_3,  .SP_AIPRIO_18
; 34 - Zombie
+spelldatad .SP_CHAOS_M1, 9,  .SP_CASTR_3,  .SP_AIPRIO_18
; 35 - Gooey Blob
+spelldatad .SP_CHAOS_M1, 9,  .SP_CASTR_13, .SP_AIPRIO_18
; 36 - Magic Fire
+spelldatad .SP_CHAOS_M1, 8,  .SP_CASTR_13, .SP_AIPRIO_18
; 37 - Magic Wood
+spelldatad .SP_CHAOS_P1, 8,  .SP_CASTR_17, .SP_AIPRIO_17
; 38 - Shadow Wood
+spelldatad .SP_CHAOS_M1, 4,  .SP_CASTR_17, .SP_AIPRIO_18
; 39 - Magic Castle
+spelldatad .SP_CHAOS_P1, 6,  .SP_CASTR_17, .SP_AIPRIO_23
; 40 - Dark Citadel
+spelldatad .SP_CHAOS_M1, 6,  .SP_CASTR_17, .SP_AIPRIO_23
; 41 - Wall
+spelldatad .SP_CHAOS_0,  8,  .SP_CASTR_13, .SP_AIPRIO_12
; 42 - Magic Bolt
+spelldatad .SP_CHAOS_0,  10, .SP_CASTR_13, .SP_AIPRIO_18
; 43 - Lightning
+spelldatad .SP_CHAOS_0,  10, .SP_CASTR_9,  .SP_AIPRIO_18
; 44 - Vengeance
+spelldatad .SP_CHAOS_M1, 8,  .SP_CASTR_41, .SP_AIPRIO_12
; 45 - Decree
+spelldatad .SP_CHAOS_P1, 8,  .SP_CASTR_41, .SP_AIPRIO_12
; 46 - Dark Power
+spelldatad .SP_CHAOS_M2, 5,  .SP_CASTR_41, .SP_AIPRIO_11
; 47 - Justice
+spelldatad .SP_CHAOS_P2, 5,  .SP_CASTR_41, .SP_AIPRIO_11
; 48 - Magic Shield
+spelldatad .SP_CHAOS_P1, 7,  .SP_CASTR_0,  .SP_AIPRIO_23
; 49 - Magic Armour
+spelldatad .SP_CHAOS_P1, 4,  .SP_CASTR_0,  .SP_AIPRIO_23
; 50 - Magic Sword
+spelldatad .SP_CHAOS_P1, 4,  .SP_CASTR_0,  .SP_AIPRIO_16
; 51 - Magic Knife
+spelldatad .SP_CHAOS_P1, 7,  .SP_CASTR_0,  .SP_AIPRIO_16
; 52 - Magic Bow
+spelldatad .SP_CHAOS_P1, 5,  .SP_CASTR_0,  .SP_AIPRIO_17
; 53 - Magic Wings
+spelldatad .SP_CHAOS_0,  5,  .SP_CASTR_0,  .SP_AIPRIO_14
; 54 - Law 1
+spelldatad .SP_CHAOS_P2, 8,  .SP_CASTR_0,  .SP_AIPRIO_5
; 55 - Law 2
+spelldatad .SP_CHAOS_P4, 6,  .SP_CASTR_0,  .SP_AIPRIO_6
; 56 - Chaos 1
+spelldatad .SP_CHAOS_M2, 8,  .SP_CASTR_0,  .SP_AIPRIO_5
; 57 - Chaos 2
+spelldatad .SP_CHAOS_M4, 6,  .SP_CASTR_0,  .SP_AIPRIO_6
; 58 - Shadow Form
+spelldatad .SP_CHAOS_0,  8,  .SP_CASTR_0,  .SP_AIPRIO_18
; 59 - Subversion
+spelldatad .SP_CHAOS_0,  10, .SP_CASTR_15, .SP_AIPRIO_18
; 60 - Raise Dead
+spelldatad .SP_CHAOS_M1, 5,  .SP_CASTR_9,  .SP_AIPRIO_18
; 61 - Turmoil
+spelldatad .SP_CHAOS_M1, 5,  .SP_CASTR_0,  .SP_AIPRIO_17


!macro spellfuncd .func {
!by (.func)
}

.SP_FUNC_DISBELIEVE = 0
.SP_FUNC_CREATURE = 1
.SP_FUNC_TREES_CASTLES = 2
.SP_FUNC_WALL = 3
.SP_FUNC_MAGIC_MISSILE = 4
.SP_FUNC_JUSTICE = 5
.SP_FUNC_MAGIC_THING = 6
.SP_FUNC_MAGIC_BOW = 7
.SP_FUNC_CHAOS_LAW = 8
.SP_FUNC_SUBVERSION = 9
.SP_FUNC_RAISE_DEAD = 10
.SP_FUNC_TURMOIL = 11

.tbl_spelldata_func:
!wo cast_disbelieve, cast_creature, cast_trees_castles, cast_wall, cast_magic_missile, cast_justice
!wo cast_magic_thing, cast_magic_bow
!wo cast_chaos_law, cast_subversion, cast_raise_dead, cast_turmoil

.tbl_spelldata_need_los:
!by 0, 1, 1, 1
!by 1, 0, 0, 0
!by 0, 1, 1, 0

spellfunc_packed = * - 1    ; make table zero based
; 1 - Disbelieve
+spellfuncd .SP_FUNC_DISBELIEVE
; 2 - King Cobra
+spellfuncd .SP_FUNC_CREATURE
; 3 - Dire Wolf
+spellfuncd .SP_FUNC_CREATURE
; 4 - Goblin
+spellfuncd .SP_FUNC_CREATURE
; 5 - Crocodile
+spellfuncd .SP_FUNC_CREATURE
; 6 - Troll
+spellfuncd .SP_FUNC_CREATURE
; 7 - Faun
+spellfuncd .SP_FUNC_CREATURE
; 8 - Lion
+spellfuncd .SP_FUNC_CREATURE
; 9 - Elf
+spellfuncd .SP_FUNC_CREATURE
; 10 - Orc
+spellfuncd .SP_FUNC_CREATURE
; 11 - Bear
+spellfuncd .SP_FUNC_CREATURE
; 12 - Gorilla
+spellfuncd .SP_FUNC_CREATURE
; 13 - Ogre
+spellfuncd .SP_FUNC_CREATURE
; 14 - Hydra
+spellfuncd .SP_FUNC_CREATURE
; 15 - Giant Rat
+spellfuncd .SP_FUNC_CREATURE
; 16 - Giant
+spellfuncd .SP_FUNC_CREATURE
; 17 - Horse
+spellfuncd .SP_FUNC_CREATURE
; 18 - Unicorn
+spellfuncd .SP_FUNC_CREATURE
; 19 - Centaur
+spellfuncd .SP_FUNC_CREATURE
; 20 - Pegasus
+spellfuncd .SP_FUNC_CREATURE
; 21 - Gryphon
+spellfuncd .SP_FUNC_CREATURE
; 22 - Manticore
+spellfuncd .SP_FUNC_CREATURE
; 23 - Bat
+spellfuncd .SP_FUNC_CREATURE
; 24 - Green Dragon
+spellfuncd .SP_FUNC_CREATURE
; 25 - Red Dragon
+spellfuncd .SP_FUNC_CREATURE
; 26 - Golden Dragon
+spellfuncd .SP_FUNC_CREATURE
; 27 - Harpy
+spellfuncd .SP_FUNC_CREATURE
; 28 - Eagle
+spellfuncd .SP_FUNC_CREATURE
; 29 - Vampire
+spellfuncd .SP_FUNC_CREATURE
; 30 - Ghost
+spellfuncd .SP_FUNC_CREATURE
; 31 - Spectre
+spellfuncd .SP_FUNC_CREATURE
; 32 - Wraith
+spellfuncd .SP_FUNC_CREATURE
; 33 - Skeleton
+spellfuncd .SP_FUNC_CREATURE
; 34 - Zombie
+spellfuncd .SP_FUNC_CREATURE
; 35 - Gooey Blob
+spellfuncd .SP_FUNC_CREATURE
; 36 - Magic Fire
+spellfuncd .SP_FUNC_CREATURE
; 37 - Magic Wood
+spellfuncd .SP_FUNC_TREES_CASTLES
; 38 - Shadow Wood
+spellfuncd .SP_FUNC_TREES_CASTLES
; 39 - Magic Castle
+spellfuncd .SP_FUNC_TREES_CASTLES
; 40 - Dark Citadel
+spellfuncd .SP_FUNC_TREES_CASTLES
; 41 - Wall
+spellfuncd .SP_FUNC_WALL
; 42 - Magic Bolt
+spellfuncd .SP_FUNC_MAGIC_MISSILE
; 43 - Lightning
+spellfuncd .SP_FUNC_MAGIC_MISSILE
; 44 - Vengeance
+spellfuncd .SP_FUNC_JUSTICE
; 45 - Decree
+spellfuncd .SP_FUNC_JUSTICE
; 46 - Dark Power
+spellfuncd .SP_FUNC_JUSTICE
; 47 - Justice
+spellfuncd .SP_FUNC_JUSTICE
; 48 - Magic Shield
+spellfuncd .SP_FUNC_MAGIC_THING
; 49 - Magic Armour
+spellfuncd .SP_FUNC_MAGIC_THING
; 50 - Magic Sword
+spellfuncd .SP_FUNC_MAGIC_THING
; 51 - Magic Knife
+spellfuncd .SP_FUNC_MAGIC_THING
; 52 - Magic Bow
+spellfuncd .SP_FUNC_MAGIC_BOW
; 53 - Magic Wings
+spellfuncd .SP_FUNC_MAGIC_THING
; 54 - Law 1
+spellfuncd .SP_FUNC_CHAOS_LAW
; 55 - Law 2
+spellfuncd .SP_FUNC_CHAOS_LAW
; 56 - Chaos 1
+spellfuncd .SP_FUNC_CHAOS_LAW
; 57 - Chaos 2
+spellfuncd .SP_FUNC_CHAOS_LAW
; 58 - Shadow Form
+spellfuncd .SP_FUNC_MAGIC_THING
; 59 - Subversion
+spellfuncd .SP_FUNC_SUBVERSION
; 60 - Raise Dead
+spellfuncd .SP_FUNC_RAISE_DEAD
; 61 - Turmoil
+spellfuncd .SP_FUNC_TURMOIL


; in:
; a = spell
; out:
; a = $80 | $00
spell_get_need_los:
    tax
    lda spellfunc_packed,x
    tax
    lda .tbl_spelldata_need_los,x
    clc
    ror
    ror
    rts

; in:
; a = spell
; out:
; a = range
spell_get_range:
    sty .spell_get_range_smc_y
    asl
    tay
    lda spelldata_packed + 1,y
    lsr
    lsr
    lsr
    lsr
    tay
    lda tbl_spelldata_castrange,y
.spell_get_range_smc_y = * + 1
    ldy #0
    rts

spell_get_range_for_print:
    jsr spell_get_range
    lsr
    cmp #10
    bcc +
    lda #20
+   rts

; in:
; a = spell
; out:
; a = current_spell = spell
; current_spell_range = spell range + 1 (for bcc comparison)
set_spell:
    sta current_spell
    jsr spell_get_range
    clc
    adc #1
    sta current_spell_range
    lda current_spell
    rts

; in:
; a = spell
spell_cast:
    tax
    lda spellfunc_packed,x
    asl
    tax
    lda .tbl_spelldata_func,x
    sta .spell_cast_dst
    lda .tbl_spelldata_func + 1,x
    sta .spell_cast_dsth
.spell_cast_dst = * + 1
.spell_cast_dsth = * + 2
    jmp cast_disbelieve

} ; !zn Spells
